/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2007-2009 by TAKAGI Nobuhisa
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */
#include <cstdlib>
#include <cerrno>
#include <string>
#include <vector>
#include <utility>
#include <algorithm>
#include <ostream>
#include <utility>
#include "toppers/macro_processor.hpp"
#include "toppers/diagnostics.hpp"
#include "toppers/gettext.hpp"
#include "toppers/cpp.hpp"
#include <boost/format.hpp>
#include <boost/utility.hpp>
#include <boost/lexical_cast.hpp>

namespace toppers
{
  namespace
  {
    typedef macro_processor::element element;
    typedef macro_processor::var_t var_t;
    typedef macro_processor::context context;

    inline std::tr1::int64_t get_i( var_t const& var, context const* p_ctx )
    {
      return macro_processor::to_integer( var, p_ctx );
    }
    inline std::string get_s( var_t const& var, context const* p_ctx )
    {
      return macro_processor::to_string( var, p_ctx );
    }

  }

  /*!
    *  \brief  ̌`FbN
    *  \param[in]  line    sԍ
    *  \param[in]  arity   ̌
    *  \param[in]  valid   ҂Ă̌
    *  \param[in]  function_name gݍ݊֐
    */
  bool macro_processor::check_arity( text_line const& line, std::size_t arity, std::size_t valid, char const* function_name )
  {
    bool result = false;
    if ( arity < valid )
    {
      error( line, _( "too few arguments for `%1%\'" ), function_name );
    }
    else if ( arity > valid )
    {
      error( line, _( "too many arguments for `%1%\'" ), function_name );
    }
    else
    {
      result = true;
    }
    return result;
  }

  /*!
   *  \brief  ϐ_v̂߂<<Zq
   *  \param[in,out]  ostr  o̓Xg[
   *  \param[in]      arg   ϐQƂ邽߂̃yA
   *  \return         ostrԂ
   *  \note ݂̎ł́Aarg.second ͎gpĂȂB
   */
  std::ostream& operator<<( std::ostream& ostr, std::pair< var_t const*, context const* > const& arg )
  {
    for ( var_t::const_iterator iter( arg.first->begin() ), last( arg.first->end() ); iter != last; ++iter )
    {
      if ( !iter->s.empty() )
      {
        ostr << iter->s;
      }
      else if ( iter->i )
      {
        ostr << iter->i.get();
      }
      if ( boost::next( iter ) != last )
      {
        ostr << ",";
      }
    }
    return ostr;
  }

  /*!
   *  \brief  Xg̒
   *  \param[in]  line      sԍ
   *  \param[in]  arg_list  }NXg
   *  \param[in]  p_ctx     }NReLXg
   *  \retval     }Nԋpl
   *  1}NƂĎw肵tXg̗vfԂB
   *  1}NtXgłȂꍇ1ԂB܂A1}Nȕϐ̏ꍇ0ԂB
   */
  var_t bf_length( text_line const& line, std::vector< var_t > const& arg_list, context* p_ctx )
  {
    element e;
    if ( macro_processor::check_arity( line, arg_list.size(), 1, "LENGTH" ) )
    {
      std::tr1::int64_t size = arg_list.front().size();
      e.i = size;
    }
    return var_t( 1, e );
  }

  /*!
   *  \brief  ̈v
   *  \param[in]  line      sԍ
   *  \param[in]  arg_list  }NXg
   *  \param[in]  p_ctx     }NReLXg
   *  \retval     }Nԋpl
   *  1}NƑ2}N𕶎ƂĔrAvꍇ͐^AłȂ΋UԂB
   */
  var_t bf_eq( text_line const& line, std::vector< var_t > const& arg_list, context* p_ctx )
  {
    element e;
    if ( macro_processor::check_arity( line, arg_list.size(), 2, "EQ" ) )
    {
      e.i = get_s( arg_list[ 0 ], p_ctx ) == get_s( arg_list[ 1 ], p_ctx );
    }
    return var_t( 1, e );
  }

  /*!
   *  \brief  ֒l
   *  \param[in]  line      sԍ
   *  \param[in]  arg_list  }NXg
   *  \param[in]  p_ctx     }NReLXg
   *  \retval     }Nԋpl
   *  1}Nȕϐ̏ꍇ͑2ԂB̑͑1ԂB
   */
  var_t bf_alt( text_line const& line, std::vector< var_t > const& arg_list, context* p_ctx )
  {
    element e;
    if ( macro_processor::check_arity( line, arg_list.size(), 2, "ALT" ) )
    {
      if ( !arg_list[0].empty() )
      {
        return arg_list[ 0 ];
      }
      else
      {
        return arg_list[ 1 ];                
      }
    }
    return var_t( 1, e );
  }

  /*!
   *  \brief  Xg̐
   *  \param[in]  line      sԍ
   *  \param[in]  arg_list  }NXg
   *  \param[in]  p_ctx     }NReLXg
   *  \retval     }Nԋpl
   *  1}NƂė^tXg̊evfA2}N̓YƂꍇ̕ϐ]A
   *  ̕]ʂɊÂɐ񂷂B
   *
   *  \example
   *  $FOO[1] = 20$
   *  $FOO[2] = 10$
   *  $FOO[3] = 30$
   *  $SORT({ 1,2,3 }, "FOO")$
   *   { 2,1,3 }
   *  \endexample
   */
  var_t bf_sort( text_line const& line, std::vector< var_t > const& arg_list, context* p_ctx )
  {
    var_t result;
    if ( macro_processor::check_arity( line, arg_list.size(), 2, "SORT" ) )
    {
      var_t list( arg_list[ 0 ] );
      std::string field( get_s( arg_list[ 1 ], p_ctx ) );
      std::vector< std::pair< element, std::tr1::int64_t > > temp;

      for ( var_t::const_iterator iter( list.begin() ), last( list.end() ); iter != last; ++iter )
      {
        std::tr1::int64_t order = iter->i.get();
        std::string name( ( boost::format( "%s[%d]" ) % field % order ).str() );
        std::map< std::string, var_t >::const_iterator m_iter( p_ctx->var_map.find( name ) );
        if ( m_iter == p_ctx->var_map.end() )
        {
          return var_t();
        }
        if ( !m_iter->second.empty() )
        {
          temp.push_back( std::make_pair( m_iter->second.front(), order ) );
        }
      }

      std::stable_sort( temp.begin(), temp.end() );

      for ( std::vector< std::pair< element, std::tr1::int64_t > >::const_iterator iter( temp.begin() ), last( temp.end() );
            iter != last;
            ++iter )
      {
        element e;
        e.i = iter->second;
        result.push_back( e );
      }
    }
    return result;
  }

  /*!
   *  \brief  ϐ̎擾
   *  \param[in]  line      sԍ
   *  \param[in]  arg_list  }NXg
   *  \param[in]  p_ctx     }NReLXg
   *  \retval     }Nԋpl
   *  1}NŎw肵ϐ̒lԂB
   */
  var_t bf_environ( text_line const& line, std::vector< var_t > const& arg_list, context* p_ctx )
  {
    element e;
    if ( macro_processor::check_arity( line, arg_list.size(), 1, "ENVIRON" ) )
    {
      std::string name = get_s( arg_list[ 0 ], p_ctx );
      char const* env = std::getenv( name.c_str() );
      if ( env == 0 )
      {
        return var_t();
      }
      e.s = env;
      errno = 0;
      char* endptr;
      if ( std::tr1::int64_t value = std::strtol( env, &endptr, 0 ) )
      {
        if ( *endptr == '\0' && errno == 0 )
        {
          e.i = value;
        }
      }
    }
    return var_t( 1, e );
  }

  /*!
   *  \brief  l̐
   *  \param[in]  line      sԍ
   *  \param[in]  arg_list  }NXg
   *  \param[in]  p_ctx     }NReLXg
   *  \retval     }Nԋpl
   *  1}NeLXgA2}N𐔒lƂāAl𐶐B
   */
  var_t bf_value( text_line const& line, std::vector< var_t > const& arg_list, context* p_ctx )
  {
    element e;
    if ( macro_processor::check_arity( line, arg_list.size(), 2, "VALUE" ) )
    {
      if ( !arg_list[0].empty() )
      {
        e.s = get_s( arg_list[ 0 ], p_ctx );
      }
      if ( !arg_list[1].empty() )
      {
        e.i = get_i( arg_list[ 1 ], p_ctx );
      }
    }
    return var_t( 1, e );
  }

  /*!
   *  \brief  ̘A
   *  \param[in]  line      sԍ
   *  \param[in]  arg_list  }NXg
   *  \param[in]  p_ctx     }NReLXg
   *  \retval     }Nԋpl
   *  1}NƑ2}NAĐV𐶐B
   */
  var_t bf_concat( text_line const& line, std::vector< var_t > const& arg_list, context* p_ctx )
  {
    element e;
    if ( macro_processor::check_arity( line, arg_list.size(), 2, "CAT" ) )
    {
      e.s = get_s( arg_list[ 0 ], p_ctx ) + get_s( arg_list[ 1 ], p_ctx );
    }
    return var_t( 1, e );
  }

  /*!
   *  \brief  Xg̏I[ɗvfǉ
   *  \param[in]  line      sԍ
   *  \param[in]  arg_list  }NXg
   *  \param[in]  p_ctx     }NReLXg
   *  \retval     }Nԋpl
   *  1}NƑ2}NAĐVtXg𐶐B
   */
  var_t bf_append( text_line const& line, std::vector< var_t > const& arg_list, context* p_ctx )
  {
    var_t result;
    if ( macro_processor::check_arity( line, arg_list.size(), 2, "APPEND" ) )
    {
      result = arg_list[ 0 ];
      result.insert( result.end(), arg_list[ 1 ].begin(), arg_list[1].end() );
    }
    return result;
  }

  /*!
   *  \brief  Xg̎wvf̎Q
   *  \param[in]  line      sԍ
   *  \param[in]  arg_list  }NXg
   *  \param[in]  p_ctx     }NReLXg
   *  \retval     }Nԋpl
   *  1}NŎw肵XǵA2}NŎw肵vfԂB
   */
  var_t bf_at( text_line const& line, std::vector< var_t > const& arg_list, context* p_ctx )
  {
    element e;
    if ( macro_processor::check_arity( line, arg_list.size(), 2, "CAT" ) )
    {
      try
      {
        e = arg_list[ 0 ].at( static_cast< std::vector< var_t >::size_type >( get_i( arg_list[1], p_ctx ) ) );
      }
      catch ( std::out_of_range& )
      {
        // Ys
        // ɉȂ  ̎_ e lł邱Ƃ
      }
    }
    return var_t( 1, e );
  }

  /*!
   *  \brief  eLXg̖|
   *  \param[in]  line      sԍ
   *  \param[in]  arg_list  }NXg
   *  \param[in]  p_ctx     }NReLXg
   *  \retval     }Nԋpl
   *  1}NŎw肵|󂷂B
   */
  var_t bf_gettext( text_line const& line, std::vector< var_t > const& arg_list, context* p_ctx )
  {
    element e;
    if ( macro_processor::check_arity( line, arg_list.size(), 1, "GETTEXT" ) )
    {
      std::string message = get_s( arg_list[ 0 ], p_ctx );
      e.s = gettext( message );
    }
    return var_t( 1, e );
  }

  /*!
   *  \brief  }N̏
   *  \param[in]  line      sԍ
   *  \param[in]  arg_list  }NXg
   *  \param[in]  p_ctx     }NReLXg
   *  \retval     }Nԋpl
   *  1}NŎw肵ɂāA2}Nȍ~B
   *  ́A%ngȂƂAprintf֐̃X[p[ZbgłB
   *  mȎdĺAboost::formatQƂ̂ƁB
   */
  var_t bf_format( text_line const& line, std::vector< var_t > const& arg_list, context* p_ctx )
  {
    element e;
    std::size_t arity = arg_list.size();
    if ( arity < 1 )
    {
      error( line, _( "too few arguments for `%1%\'" ), "FORMAT" );
    }
    boost::format fmt( get_s( arg_list[ 0 ], p_ctx ) );
    for ( std::size_t i = 1; i < arity; i++ )
    {
      std::pair< var_t const*, context const* > arg( &arg_list[i], p_ctx );
      fmt % arg;
    }
    e.s = fmt.str();
    return var_t( 1, e );
  }

  /*!
   *  \brief  tXg̒T
   *  \param[in]  line      sԍ
   *  \param[in]  arg_list  }NXg
   *  \param[in]  p_ctx     }NReLXg
   *  \retval     }Nԋpl
   *  1}NŎw肵tXgɊ܂܂2}NŎw肵lɓvfA
   *  擪珇ɒTB
   *  vf΂̗vfւ̃CfbNXAłȂ΋lԂB
   */
  var_t bf_find( text_line const& line, std::vector< var_t > const& arg_list, context* p_ctx )
  {
    element e;
    if ( macro_processor::check_arity( line, arg_list.size(), 2, "FIND" ) )
    {
      var_t list( arg_list[ 0 ] );
      std::tr1::int64_t value( get_i( arg_list[ 1 ], p_ctx ) );

      for ( var_t::const_iterator iter( list.begin() ), last( list.end() ); iter != last; ++iter )
      {
        if ( iter->i.get() == value ) // I
        {
          e.i = iter - list.begin();  // iter  RandomAccessIterator
          return var_t( 1, e );
        }
      }
    }
    return var_t();
  }

  /*!
   *  \brief  ͈͎wɂ鏇tXg
   *  \param[in]  line      sԍ
   *  \param[in]  arg_list  }NXg
   *  \param[in]  p_ctx     }NReLXg
   *  \retval     }Nԋpl
   *  1}Nōŏ̒lA2}NōŌ̒lw肷B
   *  { ŏ̒l, ŏ̒l + 1, ... Ō̒l }
   *  ƂȂ鏇tXg𐶐B
   *  Ȃꍇ͋lԂB
   */
  var_t bf_range( text_line const& line, std::vector< var_t > const& arg_list, context* p_ctx )
  {
    var_t result;
    if ( macro_processor::check_arity( line, arg_list.size(), 2, "RANGE" ) )
    {
      std::tr1::int64_t arg1( get_i( arg_list[ 0 ], p_ctx ) );
      std::tr1::int64_t arg2( get_i( arg_list[ 1 ], p_ctx ) );

      for ( ; arg1 <= arg2; ++arg1 )
      {
        element e;
        e.i = arg1;
        result.push_back( e );
      }
    }
    return result;
  }

  /*!
   *  \brief  Sϐ̃_v
   *  \param[in]  line      sԍ
   *  \param[in]  arg_list  }NXg
   *  \param[in]  p_ctx     }NReLXg
   *  \retval     }Nԋpl
   *  }Nw肵ꍇA̕񑮐Ŏw肵t@CɃ_vǋLB
   *  t@CƂāA"stdout"w肵ꍇ͕WóA"stderr"w肵ꍇ͕WG[ɏo͂B
   *  t@Cȗꍇ"stderr"w肵̂ƂĐUB
   */
  var_t bf_dump( text_line const& line, std::vector< var_t > const& arg_list, context* p_ctx )
  {
    std::size_t arity = arg_list.size();

    if ( arity > 1 )
    {
      error( line, _( "too many arguments for `%1%\'" ), "DUMP" );
    }

    std::string dump_str;

    // SϐȂ߂
    for ( std::map< std::string, var_t >::const_iterator iter( p_ctx->var_map.begin() ), last( p_ctx->var_map.end() );
          iter != last;
          ++iter )
    {
      dump_str += "$" + iter->first + "$ = { ";
      if ( !iter->second.empty() )
      {
        // eϐ̑Svf
        for ( var_t::const_iterator iter2( iter->second.begin() ), last2( iter->second.end() );
              iter2 != last2;
              ++iter2 )
        {
          dump_str += "\"" + iter2->s + "\"(";
          if ( iter2->i ) // l...
          {
            dump_str += boost::lexical_cast< std::string >( *iter2->i );
          }
          dump_str += "), ";
        }
      }
      dump_str += " }\n";
    }

    std::string filename( "stderr" );
    if ( arity == 1 )
    {
      filename = get_s( arg_list[ 0 ], p_ctx );
    }
    if ( filename == "stdout" )
    {
      fputs( dump_str.c_str(), stdout );
    }
    else if ( filename == "stderr" )
    {
      fputs( dump_str.c_str(), stderr );
    }
    else
    {
      std::FILE* stream = std::fopen( filename.c_str(), "a" );
      if ( stream != 0 )
      {
        fputs( dump_str.c_str(), stream );
        std::fclose( stream );
      }
    }
    element e;
    return var_t( 1, e );
  }

  /*!
   *  \brief  ϐ̃g[X
   *  \param[in]  line      sԍ
   *  \param[in]  arg_list  }NXg
   *  \param[in]  p_ctx     }NReLXg
   *  \retval     }Nԋpl
   *  1}NŎw肵ϐ̓eg[XB
   *  2}Nw肵ꍇA̕񑮐Ŏw肵t@CɃg[XeǋLB
   *  t@CƂāA"stdout"w肵ꍇ͕WóA"stderr"w肵ꍇ͕WG[ɏo͂B
   *  t@Cȗꍇ"stderr"w肵̂ƂĐUB
   */
  var_t bf_trace( text_line const& line, std::vector< var_t > const& arg_list, context* p_ctx )
  {
    std::size_t arity = arg_list.size();

    if ( arity < 1 )
    {
      error( line, _( "too few arguments for `%1%\'" ), "TRACE" );
    }
    else if ( arity > 2 )
    {
      error( line, _( "too many arguments for `%1%\'" ), "TRACE" );
    }

    var_t value( arg_list[ 0 ] );

    std::string trace_str = "{ ";
    for ( var_t::const_iterator iter( value.begin() ), last( value.end() );
          iter != last;
          ++iter )
    {
      trace_str += "\"" + iter->s + "\"(";
      if ( iter->i ) // l...
      {
        trace_str += boost::lexical_cast< std::string >( *iter->i ) + " as integer";
      }
      else if ( !iter->v.empty() )
      {
        trace_str += "\"" + boost::lexical_cast< std::string >( iter->v ) + "\" as string";
      }
      trace_str += "), ";
    }
    trace_str += " }\n";

    std::string filename( "stderr" );
    if ( arity == 2 )
    {
      filename = get_s( arg_list[ 1 ], p_ctx );
    }
    if ( filename == "stdout" )
    {
      fputs( trace_str.c_str(), stdout );
    }
    else if ( filename == "stderr" )
    {
      fputs( trace_str.c_str(), stderr );
    }
    else
    {
      std::FILE* stream = std::fopen( filename.c_str(), "a" );
      if ( stream != 0 )
      {
        fputs( trace_str.c_str(), stream );
        std::fclose( stream );
      }
    }

    element e;
    return var_t( 1, e );
  }

  /*!
   *  \brief  ̃GXP[v
   *  \param[in]  line      sԍ
   *  \param[in]  arg_list  }NXg
   *  \param[in]  p_ctx     }NReLXg
   *  \retval     }Nԋpl
   */
  var_t bf_escstr( text_line const& line, std::vector< var_t > const& arg_list, context* p_ctx )
  {
    element e;
    if ( macro_processor::check_arity( line, arg_list.size(), 1, "ESCSTR" ) )
    {
      std::string str( get_s( arg_list[ 0 ], p_ctx ) );
      e.s = quote_string( str );
    }
    return var_t( 1, e );
  }

  /*!
   *  \brief  ̃GXP[v
   *  \param[in]  line      sԍ
   *  \param[in]  arg_list  }NXg
   *  \param[in]  p_ctx     }NReLXg
   *  \retval     }Nԋpl
   */
  var_t bf_unescstr( text_line const& line, std::vector< var_t > const& arg_list, context* p_ctx )
  {
    element e;
    if ( macro_processor::check_arity( line, arg_list.size(), 1, "UNESCSTR" ) )
    {
      std::string str( get_s( arg_list[ 0 ], p_ctx ) );
      e.s = expand_quote( str );
    }
    return var_t( 1, e );
  }

  /*!
   *  \brief  ֐̌Ăяo
   *  \param[in]  line      sԍ
   *  \param[in]  arg_list  }NXg
   *  \param[in]  p_ctx     }NReLXg
   *  \retval     }Nԋpl
   */
  var_t bf_call( text_line const& line, std::vector< var_t > const& arg_list, context* p_ctx )
  {
    return macro_processor::call_user_function( line, arg_list, p_ctx );
  }

  namespace
  {
    struct bf_functor : std::binary_function< element const&, element const&, bool >
    {
    public:
      bf_functor( text_line const& line, std::string const& func_name, context* p_ctx )
        : line_( line ), func_name_( func_name ), p_ctx_( p_ctx )
      {
      }
      bool operator()( element const& lhs, element const& rhs )
      {
        std::vector< var_t > arg_list;
        arg_list.reserve( 3 );

        element e;
        e.s = func_name_;
        arg_list.push_back( var_t( 1, e ) );
        arg_list.push_back( var_t( 1, lhs ) );
        arg_list.push_back( var_t( 1, rhs ) );
        int arg1 = *lhs.i, arg2 = *rhs.i;

        var_t r = bf_call( line_, arg_list, p_ctx_ );
        bool result = 0;
        if ( !r.empty() )
        {
          int retval = *r.front().i;
          result = ( *r.front().i < 0 );
        }
        return result;
      }
    private:
      std::string func_name_;
      context* p_ctx_;
      text_line line_;
    };
  }

  /*!
   *  \brief  \[g
   *  \param[in]  line      sԍ
   *  \param[in]  arg_list  }NXg
   *  \param[in]  p_ctx     }NReLXg
   *  \retval     }Nԋpl
   */
  var_t bf_lsort( text_line const& line, std::vector< var_t > const& arg_list, context* p_ctx )
  {
    if ( macro_processor::check_arity( line, arg_list.size(), 2, "LSORT" ) )
    {
      var_t temp( arg_list[ 0 ] );
      std::string compare( arg_list[ 1 ].front().s );
      std::stable_sort( temp.begin(), temp.end(), bf_functor( line, compare, p_ctx ) );
      return temp;
    }
    element e;
    return var_t( 1, e );
  }

  /*!
   *  \brief  ֐ǂ̔
   *  \param[in]  line      sԍ
   *  \param[in]  arg_list  }NXg
   *  \param[in]  p_ctx     }NReLXg
   *  \retval     }Nԋpl
   */
  var_t bf_isfunction( text_line const& line, std::vector< var_t > const& arg_list, context* p_ctx )
  {
    element e;
    if ( macro_processor::check_arity( line, arg_list.size(), 1, "ISFUNCTION" ) )
    {
      std::string func_name( get_s( arg_list[ 0 ], p_ctx ) );
      if ( p_ctx->func_map.find( func_name ) != p_ctx->func_map.end() )
      {
        e.i = 1;
      }
      else
      {
        e.i = 0;
      }
    }
    return var_t( 1, e );
  }

  /*!
   *  \brief  Ȃgݍ݊֐
   *  \param[in]  line      sԍ
   *  \param[in]  arg_list  }NXg
   *  \param[in]  p_ctx     }NReLXg
   *  \retval     }Nԋpl
   *  ̑gݍ݊֐͉sȂB܂A}Ñ`FbNsȂB
   *  NOOP֐͏ "" ԂB
   *  \note       lԂȂ̂́A$NOOP()$̂悤ȎgƂłsȎQƂNȂ悤ɂ邽߁B
   */
  var_t bf_noop( text_line const& line, std::vector< var_t > const& arg_list, context* p_ctx )
  {
    element e;
    return var_t( 1, e );
  }

  macro_processor::func_t const macro_processor::builtin_function_table[] =
  {
    { "LENGTH", bf_length },
    { "EQ", bf_eq },
    { "ALT", bf_alt },
    { "SORT", bf_sort },
    { "ENVIRON", bf_environ },
    { "VALUE", bf_value },
    { "CONCAT", bf_concat },
    { "APPEND", bf_append },
    { "AT", bf_at },
    { "GETTEXT", bf_gettext },
    { "_", bf_gettext },  // GETTEXT̃Vmj
    { "FORMAT", bf_format },
    { "FIND", bf_find },
    { "RANGE", bf_range },
    { "DUMP", bf_dump },
    { "TRACE", bf_trace },
    { "ESCSTR", bf_escstr },
    { "UNESCSTR", bf_unescstr },
    { "CALL", bf_call },
    { "LSORT", bf_lsort },
    { "ISFUNCTION", bf_isfunction },
    { "NOOP", bf_noop },
    { "", 0 },
  };

}
